﻿var alertmessage="";
var isDayExpired=false;
var ShowWT=false;
var class_orig=false;
var refresh=false;
var path="/bitrix/tools/timeman.php";


System.Gadget.onSettingsClosed = function(event)
{
	if (event.closeAction == event.Action.commit)
		LoadMain();
}


function WDClose()
{
	var result=false;
	prepare=CheckState();
	if (prepare.STATE == "EXPIRED")
	{
		ShowFlyout();
	}		
	else
	{
		result=RequestData(path+"?action=close&ready=Y");		
		if (result.STATE == "CLOSED")
		{	
			alertmessage+=wd_closed+"<br>";
			ShowWorkTime(false);
			if (result.CAN_OPEN == "REOPEN")			
				ChangeButtonTo("REOPEN");	
			else 
				ChangeButtonTo("OPEN");	
		}		
		ShowStatus(alertmessage);
	}
}

function WDCloseWithAnotherTime()
{
	var result=false;
	var hh=document.getElementById('HH').value;
	var mm=document.getElementById('MM').value;
	var timestamp=parseInt(hh)*3600+parseInt(mm)*60;
	var report=document.getElementById('change_text').value;
	if (report)
	{
		result=RequestData(path+"?action=close&ready=Y","timestamp="+timestamp+"&report="+report);	
		if (result.STATE == "CLOSED")
			System.Gadget.Flyout.show=false;
	}
}

function WDOpen()
{
	var result=false;
	var action="open";
	prepare=CheckState();
	if (prepare.STATE=="CLOSED" && prepare.CAN_OPEN && prepare.CAN_OPEN == "REOPEN" || prepare.STATE=="PAUSED")
		action="reopen";
	result=RequestData(path+"?action="+action);	
	if (result.error)	
		alertmessage+=result.error+"<br>";
	else if (result.STATE == "OPENED")
	{	
		DayOpenTime=result.INFO.TIME_START;
		DayTimeLeaks=result.INFO.TIME_LEAKS;
		alertmessage+=wd_opened+"<br>";
		ShowWT = true;		
		ChangeButtonTo("CLOSED");	
	}
	else if (result.STATE == "EXPIRED")
	{	
		alertmessage+=lErrorExpire+"<br>";
		ChangeButtonTo("CLOSED");	
	}
	ShowStatus(alertmessage);
	ShowWorkTime();
}

function WDPause()
{
	var result=false;
	var action="pause";
		result=RequestData("/bitrix/tools/timeman.php?action="+action);	
		if (result && result.error)	
			alertmessage+=result.error+"<br>";
		else if(result.STATE == "PAUSED")
		{	
			if (result.INFO.TIME_START)
				DayOpenTime=result.INFO.TIME_START;
			alertmessage+=wd_pause+"<br>";	
			ShowWT = true;		
			ShowWorkTime();
			ChangeButtonTo("PAUSED");
			document.getElementById('pause_button').OnClick=WDOpen;	
		}		
	ShowStatus(alertmessage);
}

function CheckState()
{
	var result=false;
	result=RequestData(path+"?action=update","full=Y");
	return result;
}


function AutoRefresh()
{
	if (refresh == true)		
		WDUpdate();
	setTimeout('AutoRefresh()',10000);
}

function WDUpdate()
{

	var result=false;
	var state="CLOSED";
    
	result=RequestData(path+"?action=update");
	
	if (result && !result.error)
	{	
		DayOpenTime=result.INFO.TIME_START;
		DayTimeLeaks=result.INFO.TIME_LEAKS;
		TasksCount=result.TASKS_COUNT;
		isDayExpired = false;
		switch(result.STATE)
		{
			case "EXPIRED":
				alertmessage+=lErrorExpire;
				isDayExpired=true;
			break;
			case "OPENED":
				alertmessage=wd_opened;
				ShowWT = true;
				ShowWorkTime();				
			break;
			case "CLOSED":
				if (result.CAN_OPEN == "REOPEN")
					state="REOPEN";
				else 
					state="OPENED";
				ShowWT = false;
				ShowWorkTime();
				alertmessage=wd_closed;
			break;
			case "PAUSED":
				state="PAUSED";			
				alertmessage=wd_pause;
				ChangeButtonTo("REOPEN");
			break;
		}
		CheckDockGadget();
		ShowData(alertmessage,state);

	}
}

function ShowTaskList()
{
	var portal_task_list="";
	result=CheckState();
	
	if (result)
	{		
		if (result.TASKS_COUNT>0)
		{
			for (i=1;i<=result.TASKS_COUNT;i++)
			{
				task_id=parseInt(result.TASKS[i-1].ID);
				/*portal_task_list+="<span onclick=\"ShowFlyoutTask();\" style=\"width:100%;border-bottom:1px solid #E8E8E8;\">"+i+". <a href=\""+bitServer+result.TASKS[i-1].URL+"\" >"+result.TASKS[i-1].TITLE+"</a></span>";*/
				portal_task_list+="<span onclick=\"ShowFlyoutTask("+task_id+");\" style=\"width:100%;border-bottom:1px solid #E8E8E8;cursor:pointer;\">"+i+"."+result.TASKS[i-1].TITLE+"</span>";
			}
//debugger;
			document.getElementById('task_list').innerHTML=portal_task_list;
			document.getElementById('task_list').style.display="block";
		}
		else
			document.getElementById('task_list').innerHTML=lNoTasks;
		
	}
	
}

function ShowWorkTime()
{
	LoadSettings();
	if (ShowWT ==true && DayOpenTime>0)
	{
		 var tz_offset;
		 var tmN=new Date();
		 var curtime=tmN.getHours()*3600+tmN.getMinutes()*60+tmN.getSeconds();
		  if (bitTimeZone>0)
			tz_offset=bitTimeZone*3600;
		 else
			tz_offset=-tmN.getTimezoneOffset()*60;
		 document.getElementById('tm').innerHTML=HumanTime(curtime-DayOpenTime-DayTimeLeaks,tz_offset);    
		 document.getElementById('worktime').style.display = "block" ;    
		 var t=setTimeout('ShowWorkTime()',30000);
	}
	else
		document.getElementById('worktime').style.display = "none" ; 
}


function ChangeButtonTo(state)
{	
	if (state=="OPENED")
	{	
		document.getElementById('close_button').style.display="none";
		document.getElementById('open_button').style.display="block";
		document.getElementById('open_label').innerHTML=llabel_open;
		document.getElementById('pause_label').innerHTML=llabelbreak;
		document.getElementById('pause_button').onclick=WDPause;
		document.getElementById('pause_button').style.display="none";
	}
	else if (state=="CLOSED")
	{
		document.getElementById('close_button').style.display="block";
		document.getElementById('open_button').style.display="none";
		document.getElementById('pause_label').innerHTML=llabelbreak;
		document.getElementById('pause_button').onclick=WDPause;
		if (isDayExpired == true)
			document.getElementById('pause_button').style.display="none";
		else
			document.getElementById('pause_button').style.display="block";
	}
	else if (state=="REOPEN")
	{	
		document.getElementById('close_button').style.display="none";
		document.getElementById('open_button').style.display="block";
		document.getElementById('open_label').innerHTML=llabel_reopen;
		document.getElementById('pause_button').style.display="none";
	}
	else if (state=="PAUSED")
	{
		document.getElementById('pause_button').style.display="block";
		document.getElementById('pause_label').innerHTML=llabel_reopen;
		document.getElementById('close_button').style.display="block";
		document.getElementById('open_button').style.display="none";
		document.getElementById('pause_button').onclick=WDOpen;	
	}
}

function LoadSettings()
{
	
	bitServer = System.Gadget.Settings.read("bitServer");
	bitLogin = System.Gadget.Settings.read("bitLogin");
	bitPassword = System.Gadget.Settings.read("bitPassword");
	bitSession = System.Gadget.Settings.read("bitSessID");
	bitTimeZone = System.Gadget.Settings.read("bitTimeZone");
}

function LoadMain()
{
	System.Gadget.settingsUI = "settings.html";
	System.Gadget.Flyout.file="flyout.html";
	UpdateData();
	System.Gadget.onUndock = CheckDockGadget;
	System.Gadget.onDock = CheckDockGadget;
}

function CheckDockGadget()
{	
	var maindiv = document.getElementById('maindiv');
	var buttons = document.getElementById('buttons');
	var inf_area = document.getElementById('inf_area');
	var tasks = document.getElementById('tasks');
	var add_info = document.getElementById('additional_info');
	if (System.Gadget.docked)
    {
        background.style.width="150px";
		background.style.height="170px";
		background.blur=0;
		inf_area.className="";
		tasks.style.display="none";
		add_info.className="additional-info";
		with (document.body.style)
		{
			height = "170px";
			width = "150px";
		}	
    }
	else
	{
		ShowTaskList();
		background.style.width="350px";
		tasks.style.display="block";
		inf_area.className="infarea-undock";
		add_info.className="additional-info-undock";
		background.style.height="400px";
		with (document.body.style)
		{
			height = "400px";
			width = "350px";
		}	
	
	}
}

function UpdateTaskCount()
{
	document.getElementById('tcount').innerHTML="<a href='javascript:ShowTaskList();'>"+TasksCount+"</a>";
}

function UpdateTimeLeaks()
{
	document.getElementById('time_leak').innerHTML=HumanTime(DayTimeLeaks,bitTimeZone*3600);
}

function UpdateData()
{
	WDUpdate();
	UpdateTimeLeaks();
	UpdateTaskCount();
}

function ShowData(status_text,state)
{
	ChangeButtonTo(state);
	ShowStatus(status_text);
	refresh=true;
	document.getElementById('error').style.display="none";	
	document.getElementById('maindiv').style.display="block";
}


//flyout control
function ShowFlyout()
{
	System.Gadget.Flyout.file="flyout.html";
	System.Gadget.Flyout.show = true;
	
	System.Gadget.Flyout.onHide=function()
	{		
		UpdateData();
	};
}



function ShowFlyoutTask(ID)
{
	current_task=ID;
	
	task_data = GetTask(current_task);
	
	if (task_data)
	{
		task_content="<table style='width:90%;font-size:11px;line-height: 1.2em;'>";
		task_content+="<tr><td colspan=\"2\"><b>"+task_data.TITLE+"</b></td></tr>";
		for (i=0;i<=(task_data.PROPS.length-1);i++)
		{
			task_content+="<tr><td colspan=\"2\"><hr style='border:1px dotted;'></td></tr>";
			for(j=0;j<=(task_data.PROPS[i].length-1);j++)
			{
				task_content+="<tr>";
				task_content+="<td align=\"left\" style='color:#828282;'>"+task_data.PROPS[i][j].title+":</td><td>"+task_data.PROPS[i][j].value+"</td>";
				task_content+="</tr>";
			}
			
		}
	task_content+="</table>";
		//debugger;
	}
	
	
	System.Gadget.Flyout.file="flyout_task.html";	
	System.Gadget.Flyout.show = true;
	System.Gadget.Flyout.onShow=function()
	{		
	
	};
	
}

function GetTask(id)
{
	return RequestData(path+"?action=task_show","id="+id);	
}

function LoadFlyoutTask()
{

	var FlyoutContentDiv=document.getElementById('FlyoutContentDiv');
	LoadFlyout();
	FlyoutContentDiv.innerHTML=System.Gadget.document.parentWindow.task_content;
//	debugger;
	
}

function LoadFlyout() 
{
	var bg = document.getElementById('background');
	document.body.style.width = "300px";
	document.body.style.height = "200px";
	bg.style.width="300px";
	bg.style.height="200px";
}

AutoRefresh();